Bump to version 1.22.1
[platform/upstream/busybox.git] / coreutils / uudecode.c
index 6ac9f1b..b298fcb 100644 (file)
-/* uudecode.c -- uudecode utility.
- * Copyright (C) 1994, 1995 Free Software Foundation, Inc.
+/* vi: set sw=4 ts=4: */
+/*
+ * Copyright 2003, Glenn McGrath
  *
- * This product is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
+ * Licensed under GPLv2 or later, see file LICENSE in this source tree.
  *
- * This product is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
+ * Based on specification from
+ * http://www.opengroup.org/onlinepubs/007904975/utilities/uuencode.html
  *
- * You should have received a copy of the GNU General Public License
- * along with this product; see the file COPYING.  If not, write to
- * the Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
- * 02111-1307, USA.
- *
- * Reworked to GNU style by Ian Lance Taylor, ian@airs.com, August 93.
- *
- * Original copyright notice is retained at the end of this file.
+ * Bugs: the spec doesn't mention anything about "`\n`\n" prior to the
+ * "end" line
  */
 
-
-
-#include <stdio.h>
-#include <errno.h>
-#include <getopt.h>
-#include <string.h>
-#include <stdlib.h>
-#include "busybox.h"
-#include "pwd_grp/pwd.h"
-#include "pwd_grp/grp.h"
-
-/*struct passwd *getpwnam();*/
-
-/* Single character decode.  */
-#define        DEC(Char) (((Char) - ' ') & 077)
-
-static int read_stduu (const char *inname)
+//usage:#define uudecode_trivial_usage
+//usage:       "[-o OUTFILE] [INFILE]"
+//usage:#define uudecode_full_usage "\n\n"
+//usage:       "Uudecode a file\n"
+//usage:       "Finds OUTFILE in uuencoded source unless -o is given"
+//usage:
+//usage:#define uudecode_example_usage
+//usage:       "$ uudecode -o busybox busybox.uu\n"
+//usage:       "$ ls -l busybox\n"
+//usage:       "-rwxr-xr-x   1 ams      ams        245264 Jun  7 21:35 busybox\n"
+
+#include "libbb.h"
+
+#if ENABLE_UUDECODE
+static void FAST_FUNC read_stduu(FILE *src_stream, FILE *dst_stream, int flags UNUSED_PARAM)
 {
-  char buf[2 * BUFSIZ];
-
-  while (1) {
-    int n;
-    char *p;
-
-    if (fgets (buf, sizeof(buf), stdin) == NULL) {
-      error_msg("%s: Short file", inname);
-      return FALSE;
-    }
-    p = buf;
-
-    /* N is used to avoid writing out all the characters at the end of
-       the file.  */
-    n = DEC (*p);
-    if (n <= 0)
-      break;
-    for (++p; n > 0; p += 4, n -= 3) {
-      char ch;
-
-      if (n >= 3) {
-        ch = DEC (p[0]) << 2 | DEC (p[1]) >> 4;
-        putchar (ch);
-        ch = DEC (p[1]) << 4 | DEC (p[2]) >> 2;
-        putchar (ch);
-        ch = DEC (p[2]) << 6 | DEC (p[3]);
-        putchar (ch);
-      } else {
-        if (n >= 1) {
-          ch = DEC (p[0]) << 2 | DEC (p[1]) >> 4;
-          putchar (ch);
-        }
-        if (n >= 2) {
-          ch = DEC (p[1]) << 4 | DEC (p[2]) >> 2;
-          putchar (ch);
-        }
-      }
-    }
-  }
-
-  if (fgets (buf, sizeof(buf), stdin) == NULL
-      || strcmp (buf, "end\n")) {
-    error_msg("%s: No `end' line", inname);
-    return FALSE;
-  }
-
-  return TRUE;
+       char *line;
+
+       while ((line = xmalloc_fgetline(src_stream)) != NULL) {
+               int encoded_len, str_len;
+               char *line_ptr, *dst;
+
+               if (strcmp(line, "end") == 0) {
+                       return; /* the only non-error exit */
+               }
+
+               line_ptr = line;
+               while (*line_ptr) {
+                       *line_ptr = (*line_ptr - 0x20) & 0x3f;
+                       line_ptr++;
+               }
+               str_len = line_ptr - line;
+
+               encoded_len = line[0] * 4 / 3;
+               /* Check that line is not too short. (we tolerate
+                * overly _long_ line to accomodate possible extra '`').
+                * Empty line case is also caught here. */
+               if (str_len <= encoded_len) {
+                       break; /* go to bb_error_msg_and_die("short file"); */
+               }
+               if (encoded_len <= 0) {
+                       /* Ignore the "`\n" line, why is it even in the encode file ? */
+                       free(line);
+                       continue;
+               }
+               if (encoded_len > 60) {
+                       bb_error_msg_and_die("line too long");
+               }
+
+               dst = line;
+               line_ptr = line + 1;
+               do {
+                       /* Merge four 6 bit chars to three 8 bit chars */
+                       *dst++ = line_ptr[0] << 2 | line_ptr[1] >> 4;
+                       encoded_len--;
+                       if (encoded_len == 0) {
+                               break;
+                       }
+
+                       *dst++ = line_ptr[1] << 4 | line_ptr[2] >> 2;
+                       encoded_len--;
+                       if (encoded_len == 0) {
+                               break;
+                       }
+
+                       *dst++ = line_ptr[2] << 6 | line_ptr[3];
+                       line_ptr += 4;
+                       encoded_len -= 2;
+               } while (encoded_len > 0);
+               fwrite(line, 1, dst - line, dst_stream);
+               free(line);
+       }
+       bb_error_msg_and_die("short file");
 }
+#endif
 
-static int read_base64 (const char *inname)
+#if ENABLE_UUDECODE
+int uudecode_main(int argc, char **argv) MAIN_EXTERNALLY_VISIBLE;
+int uudecode_main(int argc UNUSED_PARAM, char **argv)
 {
-  static const char b64_tab[256] = {
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*000-007*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*010-017*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*020-027*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*030-037*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*040-047*/
-    '\177', '\177', '\177', '\76',  '\177', '\177', '\177', '\77',  /*050-057*/
-    '\64',  '\65',  '\66',  '\67',  '\70',  '\71',  '\72',  '\73',  /*060-067*/
-    '\74',  '\75',  '\177', '\177', '\177', '\100', '\177', '\177', /*070-077*/
-    '\177', '\0',   '\1',   '\2',   '\3',   '\4',   '\5',   '\6',   /*100-107*/
-    '\7',   '\10',  '\11',  '\12',  '\13',  '\14',  '\15',  '\16',  /*110-117*/
-    '\17',  '\20',  '\21',  '\22',  '\23',  '\24',  '\25',  '\26',  /*120-127*/
-    '\27',  '\30',  '\31',  '\177', '\177', '\177', '\177', '\177', /*130-137*/
-    '\177', '\32',  '\33',  '\34',  '\35',  '\36',  '\37',  '\40',  /*140-147*/
-    '\41',  '\42',  '\43',  '\44',  '\45',  '\46',  '\47',  '\50',  /*150-157*/
-    '\51',  '\52',  '\53',  '\54',  '\55',  '\56',  '\57',  '\60',  /*160-167*/
-    '\61',  '\62',  '\63',  '\177', '\177', '\177', '\177', '\177', /*170-177*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*200-207*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*210-217*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*220-227*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*230-237*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*240-247*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*250-257*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*260-267*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*270-277*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*300-307*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*310-317*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*320-327*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*330-337*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*340-347*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*350-357*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*360-367*/
-    '\177', '\177', '\177', '\177', '\177', '\177', '\177', '\177', /*370-377*/
-  };
-  unsigned char buf[2 * BUFSIZ];
-
-  while (1) {
-    int last_data = 0;
-    unsigned char *p;
-
-    if (fgets (buf, sizeof(buf), stdin) == NULL) {
-      error_msg("%s: Short file", inname);
-      return FALSE;
-    }
-    p = buf;
-
-    if (memcmp (buf, "====", 4) == 0)
-      break;
-    if (last_data != 0) {
-      error_msg("%s: data following `=' padding character", inname);
-      return FALSE;
-    }
-
-    /* The following implementation of the base64 decoding might look
-       a bit clumsy but I only try to follow the POSIX standard:
-       ``All line breaks or other characters not found in the table
-       [with base64 characters] shall be ignored by decoding
-       software.''  */
-    while (*p != '\n') {
-      char c1, c2, c3;
-
-      while ((b64_tab[*p] & '\100') != 0)
-        if (*p == '\n' || *p++ == '=')
-          break;
-      if (*p == '\n')
-        /* This leaves the loop.  */
-        continue;
-      c1 = b64_tab[*p++];
-
-      while ((b64_tab[*p] & '\100') != 0)
-        if (*p == '\n' || *p++ == '=') {
-          error_msg("%s: illegal line", inname);
-          return FALSE;
-        }
-      c2 = b64_tab[*p++];
-
-      while (b64_tab[*p] == '\177')
-        if (*p++ == '\n') {
-          error_msg("%s: illegal line", inname);
-          return FALSE;
-        }
-      if (*p == '=') {
-        putchar (c1 << 2 | c2 >> 4);
-        last_data = 1;
-        break;
-      }
-      c3 = b64_tab[*p++];
-
-      while (b64_tab[*p] == '\177')
-        if (*p++ == '\n') {
-          error_msg("%s: illegal line", inname);
-          return FALSE;
-        }
-      putchar (c1 << 2 | c2 >> 4);
-      putchar (c2 << 4 | c3 >> 2);
-      if (*p == '=') {
-        last_data = 1;
-        break;
-      }
-      else
-        putchar (c3 << 6 | b64_tab[*p++]);
-    }
-  }
-
-  return TRUE;
+       FILE *src_stream;
+       char *outname = NULL;
+       char *line;
+
+       opt_complementary = "?1"; /* 1 argument max */
+       getopt32(argv, "o:", &outname);
+       argv += optind;
+
+       if (!argv[0])
+               *--argv = (char*)"-";
+       src_stream = xfopen_stdin(argv[0]);
+
+       /* Search for the start of the encoding */
+       while ((line = xmalloc_fgetline(src_stream)) != NULL) {
+               void FAST_FUNC (*decode_fn_ptr)(FILE *src, FILE *dst, int flags);
+               char *line_ptr;
+               FILE *dst_stream;
+               int mode;
+
+               if (strncmp(line, "begin-base64 ", 13) == 0) {
+                       line_ptr = line + 13;
+                       decode_fn_ptr = read_base64;
+               } else if (strncmp(line, "begin ", 6) == 0) {
+                       line_ptr = line + 6;
+                       decode_fn_ptr = read_stduu;
+               } else {
+                       free(line);
+                       continue;
+               }
+
+               /* begin line found. decode and exit */
+               mode = bb_strtou(line_ptr, NULL, 8);
+               if (outname == NULL) {
+                       outname = strchr(line_ptr, ' ');
+                       if (!outname)
+                               break;
+                       outname++;
+                       if (!outname[0])
+                               break;
+               }
+               dst_stream = stdout;
+               if (NOT_LONE_DASH(outname)) {
+                       dst_stream = xfopen_for_write(outname);
+                       fchmod(fileno(dst_stream), mode & (S_IRWXU | S_IRWXG | S_IRWXO));
+               }
+               free(line);
+               decode_fn_ptr(src_stream, dst_stream, /*flags:*/ BASE64_FLAG_UU_STOP + BASE64_FLAG_NO_STOP_CHAR);
+               /* fclose_if_not_stdin(src_stream); - redundant */
+               return EXIT_SUCCESS;
+       }
+       bb_error_msg_and_die("no 'begin' line");
 }
+#endif
 
-static int decode (const char *inname,
-                   const char *forced_outname)
-{
-  struct passwd *pw;
-  register int n;
-  register char *p;
-  int mode, n1;
-  char buf[2 * BUFSIZ];
-  char *outname;
-  int do_base64 = 0;
-  int res;
-  int dofre;
-
-  /* Search for header line.  */
-
-  while (1) {
-    if (fgets (buf, sizeof (buf), stdin) == NULL) {
-      error_msg("%s: No `begin' line", inname);
-      return FALSE;
-    }
+//applet:IF_BASE64(APPLET(base64, BB_DIR_BIN, BB_SUID_DROP))
 
-    if (strncmp (buf, "begin", 5) == 0) {
-      if (sscanf (buf, "begin-base64 %o %s", &mode, buf) == 2) {
-        do_base64 = 1;
-        break;
-      } else if (sscanf (buf, "begin %o %s", &mode, buf) == 2)
-        break;
-    }
-  }
+//kbuild:lib-$(CONFIG_BASE64) += uudecode.o
 
-  /* If the output file name is given on the command line this rules.  */
-  dofre = FALSE;
-  if (forced_outname != NULL)
-    outname = (char *) forced_outname;
-  else {
-    /* Handle ~user/file format.  */
-    if (buf[0] != '~')
-      outname = buf;
-    else {
-      p = buf + 1;
-      while (*p != '/')
-        ++p;
-      if (*p == '\0') {
-        error_msg("%s: Illegal ~user", inname);
-        return FALSE;
-      }
-      *p++ = '\0';
-      pw = getpwnam (buf + 1);
-      if (pw == NULL) {
-        error_msg("%s: No user `%s'", inname, buf + 1);
-        return FALSE;
-      }
-      n = strlen (pw->pw_dir);
-      n1 = strlen (p);
-      outname = (char *) xmalloc ((size_t) (n + n1 + 2));
-      memcpy (outname + n + 1, p, (size_t) (n1 + 1));
-      memcpy (outname, pw->pw_dir, (size_t) n);
-      outname[n] = '/';
-      dofre = TRUE;
-    }
-  }
+//config:config BASE64
+//config:      bool "base64"
+//config:      default y
+//config:      help
+//config:        Base64 encode and decode
 
-  /* Create output file and set mode.  */
-  if (strcmp (outname, "/dev/stdout") != 0 && strcmp (outname, "-") != 0
-      && (freopen (outname, "w", stdout) == NULL
-         || chmod (outname, mode & (S_IRWXU | S_IRWXG | S_IRWXO))
-         )) {
-    perror_msg("%s", outname); /* */
-    if (dofre)
-       free(outname);
-    return FALSE;
-  }
+//usage:#define base64_trivial_usage
+//usage:       "[-d] [FILE]"
+//usage:#define base64_full_usage "\n\n"
+//usage:       "Base64 encode or decode FILE to standard output"
+//usage:     "\n       -d      Decode data"
+////usage:     "\n     -w COL  Wrap lines at COL (default 76, 0 disables)"
+////usage:     "\n     -i      When decoding, ignore non-alphabet characters"
 
-  /* We differenciate decoding standard UU encoding and base64.  A
-     common function would only slow down the program.  */
-
-  /* For each input line:  */
-  if (do_base64)
-      res = read_base64 (inname);
-  else
-       res = read_stduu (inname);
-  if (dofre)
-      free(outname);
-  return res;
-}
-
-int uudecode_main (int argc,
-                   char **argv)
+#if ENABLE_BASE64
+int base64_main(int argc, char **argv) MAIN_EXTERNALLY_VISIBLE;
+int base64_main(int argc UNUSED_PARAM, char **argv)
 {
-  int opt;
-  int exit_status;
-  const char *outname;
-  outname = NULL;
-
-  while ((opt = getopt(argc, argv, "o:")) != EOF) {
-    switch (opt) {
-     case 0:
-      break;
-
-     case 'o':
-      outname = optarg;
-      break;
-
-     default:
-      show_usage();
-    }
-  }
-
-  if (optind == argc)
-    exit_status = decode ("stdin", outname) == 0 ? EXIT_SUCCESS : EXIT_FAILURE;
-  else {
-    exit_status = EXIT_SUCCESS;
-    do {
-      if (freopen (argv[optind], "r", stdin) != NULL) {
-        if (decode (argv[optind], outname) != 0)
-          exit_status = FALSE;
-      } else {
-        perror_msg("%s", argv[optind]);
-        exit_status = EXIT_FAILURE;
-      }
-      optind++;
-    }
-    while (optind < argc);
-  }
-  return(exit_status);
+       FILE *src_stream;
+       unsigned opts;
+
+       opt_complementary = "?1"; /* 1 argument max */
+       opts = getopt32(argv, "d");
+       argv += optind;
+
+       if (!argv[0])
+               *--argv = (char*)"-";
+       src_stream = xfopen_stdin(argv[0]);
+       if (opts) {
+               read_base64(src_stream, stdout, /*flags:*/ (char)EOF);
+       } else {
+               enum {
+                       SRC_BUF_SIZE = 76/4*3,  /* This *MUST* be a multiple of 3 */
+                       DST_BUF_SIZE = 4 * ((SRC_BUF_SIZE + 2) / 3),
+               };
+               char src_buf[SRC_BUF_SIZE];
+               char dst_buf[DST_BUF_SIZE + 1];
+               int src_fd = fileno(src_stream);
+               while (1) {
+                       size_t size = full_read(src_fd, src_buf, SRC_BUF_SIZE);
+                       if (!size)
+                               break;
+                       if ((ssize_t)size < 0)
+                               bb_perror_msg_and_die(bb_msg_read_error);
+                       /* Encode the buffer we just read in */
+                       bb_uuencode(dst_buf, src_buf, size, bb_uuenc_tbl_base64);
+                       xwrite(STDOUT_FILENO, dst_buf, 4 * ((size + 2) / 3));
+                       bb_putchar('\n');
+                       fflush(stdout);
+               }
+       }
+
+       fflush_stdout_and_exit(EXIT_SUCCESS);
 }
-
-/* Copyright (c) 1983 Regents of the University of California.
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * 3. <BSD Advertising Clause omitted per the July 22, 1999 licensing change 
- *             ftp://ftp.cs.berkeley.edu/pub/4bsd/README.Impt.License.Change> 
- *
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- */
-
-
+#endif
+
+/* Test script.
+Put this into an empty dir with busybox binary, an run.
+
+#!/bin/sh
+test -x busybox || { echo "No ./busybox?"; exit; }
+ln -sf busybox uudecode
+ln -sf busybox uuencode
+>A_null
+echo -n A >A
+echo -n AB >AB
+echo -n ABC >ABC
+echo -n ABCD >ABCD
+echo -n ABCDE >ABCDE
+echo -n ABCDEF >ABCDEF
+cat busybox >A_bbox
+for f in A*; do
+    echo uuencode $f
+    ./uuencode    $f <$f >u_$f
+    ./uuencode -m $f <$f >m_$f
+done
+mkdir unpk_u unpk_m 2>/dev/null
+for f in u_*; do
+    ./uudecode <$f -o unpk_u/${f:2}
+    diff -a ${f:2} unpk_u/${f:2} >/dev/null 2>&1
+    echo uudecode $f: $?
+done
+for f in m_*; do
+    ./uudecode <$f -o unpk_m/${f:2}
+    diff -a ${f:2} unpk_m/${f:2} >/dev/null 2>&1
+    echo uudecode $f: $?
+done
+*/